;===============;
;New Sprite	    ;
;===============;
Stationfrm: db $00,$01
Xdisp: db $10,$F0
Fogspd1: db $30,$C0
Fogspd2: db $01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,$10
	 db $FF,$FE,$FD,$FC,$FB,$FA,$F9,$F8,$F7,$F6,$F5,$F4,$F3,$F2,$F1,$F0

!fog_cloud = #$0F
!XLoPos			= $1E16
!XHiPos			= $1E3E
!YLoPos			= $1E02
!YHiPos			= $1E2A
!XVel			= $1E66
!YVel			= $1E52
!XFractionBits		= $1E7A
!YFractionBits		= $1E8E
!IsOffScreen		= $0F9A
;;;;;;;;;;;;;;

print "INIT ",pc
 STZ $C2,x
	RTL

print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR Run
	PLB
	RTL

Return:
	RTS

Run:
	JSR Graphics
	LDA $9D
	BNE Return
	LDA $14C8,x
	CMP #$08
	BNE Return
	LDY $157C,x
	LDA Fogspd1,y
	STA $1570,x
	LDA #$1E
	JSL RANDOM
	TAY
	LDA Fogspd2,y
	STA $151C,x
	JSR SUB_HORZ_POS
	TYA	
	STA $157C,x
	JSR SUB_OFF_SCREEN_X0
	JSR cont
	LDA $C2,x
	JSL $0086DF
ptr:
dw .state1  ;station
dw .state2  ;blow side
dw .state3  ;blow up (unsd)

.state1
JSR prox
LDA $14
LSR #4
AND #$01
TAY
LDA Stationfrm,y
STA $187B,x
RTS

.state2
JSR prox
LDA #$03
STA $187B,x
LDA $14
AND #$02
BNE .stuf
JSR .cloudside
.stuf
RTS

.state3
JSR prox
LDA #$02
STA $187B,x
LDA $14
AND #$02
BNE .stuf
RTS

.cloudside
		LDY	#$13
.loop1			
		LDA	$1892,y
		BEQ	.slot_found1
		DEY	
		BPL	.loop1
.return1			
		RTS	
.slot_found1		
		LDA	#$01
		STA	$18B8
		LDA	#!fog_cloud
		STA	$1892,y
		PHY
		LDY $157C,x
		LDA Xdisp,y
		STA $1602,x
		PLY
		LDA	$E4,x
		CLC
		ADC $1602,x
		STA	!XLoPos,y
		LDA	$14E0,x
		STA	!XHiPos,y
		LDA	$D8,x
		SEC
		SBC 	#$05
		STA	!YLoPos,y
		LDA	$14D4,x
		STA	!YHiPos,y
  		LDA 	$1570,x
		STA	!XVel,y
 		LDA 	$151C,x
  		STA	!YVel,y
		LDA	#$00
		STA	!IsOffScreen,y
		LDA #$1A
		STA $1E79,y
  LDA #$0A
  STA $163E,x
  LDA #$50
  STA $1540,x
  RTS	
  
;;;;;;;;;;;;;;;
 prox:
 LDA #$50
 STA $00
 JSR Proximity
 CMP #$01
 BEQ .return
 LDA #$01
 STA $C2,x
 RTS
 .return
 STZ $C2,x
 RTS

cont:
JSL $01A7DC
BCC .return
JSR SUB_VERT_POS
LDA $0E
CMP #$E6
BMI .die
LDA $1490
BNE .die2
JSL $00F5B7
.return
RTS
.die
JSL $01AA33
JSL $01AB99
.die2
LDA #$02
STA $1DF9
STA $14C8,x
RTS
 
 ;=========================================;
;Proximity (horizontal)		      
;A will have 1 if the sprite is in range
;Otherwise it's 0			     
;=========================================;

;Store the range to check from in 00, then jump to this routine.
;E.g.
;LDA #$12
;STA $00
;JSR Proximity

DirFix: db $FF,$00

Proximity:
	LDY #$00
	LDA $E4,x		        ;\
	SEC				            ; |
	SBC $94			         ; |
	PHA				            ; |
	JSR SUB_HORZ_POS	  ; | Check sprite range ..
	PLA				            ; |
	EOR DirFix,y		     ; |
	CMP $00			         ; | If Range > !Temp return.
	BCC +			           ; | If in RANGE.. branch.
 	LDA #$01           ; |
	RTS				            ;/
+	
 	LDA #$00
	RTS


RANDOM:
	PHX
	PHP
	SEP #$30
	PHA
	JSL $01ACF9
	PLX
	CPX #$FF
	BNE NORMALRT
	LDA $148B
	BRA ENDRANDOM
NORMALRT:
	INX
	LDA $148B
	STA $4202
	STX $4203
	NOP #4
	LDA $4217	
ENDRANDOM:
	PLP
	PLX
	RTL
	

;;;;;;;;;;;;;;;;;;;;;;;;;;

TILEMAP:             
    db $20,$22,$40,$42,$24,$26,$44,$46,$28,$2A,$48,$4A,$2C,$2E,$4C,$4E
    db $20,$22,$40,$42,$24,$26,$44,$46,$28,$2A,$48,$4A,$2C,$2E,$4C,$4E
    
YDISP:           
    db $F0,$F0,$00,$00
    
XDISP:
    db $F8,$08,$F8,$08
    db $08,$F8,$08,$F8

PROPERTIES:
    db $4D,$0D

Graphics:
    JSR GET_DRAW_INFO
    
    LDA $187B,x
    ASL #2
    STA $03

    LDA $157C,x
    STA $02  
    
    PHX		
    LDX #$03		
Loop:		
    PHX		
    LDA $02		
    BNE NoAdd
    INX #4		
NoAdd:	
    LDA $00		
    CLC		
    ADC XDISP,x	
    STA $0300,y
    	
    PLX		
    LDA $01		
    CLC		
    ADC YDISP,x	
    STA $0301,y
    	
    PHX		
    TXA		
    CLC		
    ADC $03		
    TAX		
    LDA TILEMAP,x	
    STA $0302,y	
    
    PHX
    LDX $02
    LDA PROPERTIES,x
    ORA $64
    STA $0303,y  
    PLX
    
    INY #4
    PLX
    DEX
    BPL Loop
    PLX
    LDY #$02
    LDA #$03
    JSL $01B7B3
    RTS

;region Sprite Routines

;=================;
;SUB_HORZ_POS
;=================;

SUB_HORZ_POS:
	LDY #$00
	LDA $D1
	SEC
	SBC $E4,x
	STA $0F
	LDA $D2
	SBC $14E0,x
	BPL SPR_L16
	INY
SPR_L16:
	RTS

;=================;
;SUB_VERT_POS
;=================;

SUB_VERT_POS:
	LDY #$00
	LDA $D3
	SEC
	SBC $D8,x
	STA $0F
	LDA $D4
	SBC $14D4,x
	BPL SPR_L11
	INY
SPR_L11:
	RTS

;=================;
;SUB_OFF_SCREEN
;=================;

SPR_T12:
	db $40,$B0
SPR_T13:
	db $01,$FF
SPR_T14:
	db $30,$C0,$A0,$C0,$A0,$F0,$60,$90
	db $30,$C0,$A0,$80,$A0,$40,$60,$B0
SPR_T15:
	db $01,$FF,$01,$FF,$01,$FF,$01,$FF
	db $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X1:
	LDA #$02
	BRA STORE_03
SUB_OFF_SCREEN_X2:
	LDA #$04
	BRA STORE_03
SUB_OFF_SCREEN_X3:
	LDA #$06
	BRA STORE_03
SUB_OFF_SCREEN_X4:
	LDA #$08
	BRA STORE_03
SUB_OFF_SCREEN_X5:
	LDA #$0A
	BRA STORE_03
SUB_OFF_SCREEN_X6:
	LDA #$0C
	BRA STORE_03
SUB_OFF_SCREEN_X7:
	LDA #$0E
STORE_03:
	STA $03
	BRA START_SUB
SUB_OFF_SCREEN_X0:
	STZ $03

START_SUB:
	JSR SUB_IS_OFF_SCREEN
	BEQ RETURN_35
	LDA $5B
	AND #$01
	BNE VERTICAL_LEVEL
	LDA $D8,x
	CLC
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BPL ERASE_SPRITE
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	AND #$01
	ORA $03
	STA $01
	TAY
	LDA $1A
	CLC
	ADC SPR_T14,y
	ROL $00
	CMP $E4,x
	PHP
	LDA $1B
	LSR $00
	ADC SPR_T15,y
	PLP
	SBC $14E0,x
	STA $00
	LSR $01
	BCC SPR_L31
	EOR #$80
	STA $00
SPR_L31:
	LDA $00
	BPL RETURN_35
	ERASE_SPRITE:
	LDA $14C8,x
	CMP #$08
	BCC KILL_SPRITE
	LDY $161A,x
	CPY #$FF
	BEQ KILL_SPRITE
	LDA #$00
	STA $1938,y
KILL_SPRITE:
	STZ $14C8,x
RETURN_35:
	RTS

VERTICAL_LEVEL:
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	LSR A
	BCS RETURN_35
	LDA $E4,x
	CMP #$00
	LDA $14E0,x
	SBC #$00
	CMP #$02
	BCS ERASE_SPRITE
	LDA $13
	LSR A
	AND #$01
	STA $01
	TAY
	LDA $1C
	CLC
	ADC SPR_T12,y
	ROL $00
	CMP $D8,x
	PHP
	LDA $001D
	LSR $00
	ADC SPR_T13,y
	PLP
	SBC $14D4,x
	STA $00
	LDY $01
	BEQ SPR_L38
	EOR #$80
	STA $00
SPR_L38:
	LDA $00
	BPL RETURN_35
	BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN:
	LDA $15A0,x
	ORA $186C,x
	RTS

;================;
;GET_DRAW_INFO
;================;

SPR_T1:
	db $0C,$1C
SPR_T2:
	db $01,$02

GET_DRAW_INFO:
	STZ $186C,x
	STZ $15A0,x
	LDA $E4,x
	CMP $1A
	LDA $14E0,x
	SBC $1B
	BEQ ON_SCREEN_X
	INC $15A0,x

ON_SCREEN_X:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $1A
	CLC
	ADC.w #$0040
	CMP.w #$0180
	SEP #$20
	ROL A
	AND #$01
	STA $15C4,x
	BNE INVALID

	LDY #$00
	LDA $1662,x
	AND #$20
	BEQ ON_SCREEN_LOOP
	INY
ON_SCREEN_LOOP:
	LDA $D8,x
	CLC
	ADC SPR_T1,y
	PHP
	CMP $1C
	ROL $00
	PLP
	LDA $14D4,x
	ADC #$00
	LSR $00
	SBC $1D
	BEQ ON_SCREEN_Y
	LDA $186C,x
	ORA SPR_T2,y
	STA $186C,x
ON_SCREEN_Y:
	DEY
	BPL ON_SCREEN_LOOP
	LDY $15EA,x
	LDA $E4,x
	SEC
	SBC $1A
	STA $00
	LDA $D8,x
	SEC
	SBC $1C
	STA $01
	RTS

INVALID:
	PLA
	PLA
	RTS
;endregion